;                         ͻ
;                                MINI_DBG.MSG       
;                                version 1.00       
;                                                   
;                               12 / 03 / 1995      
;                         ͼ

;  Source for Assemble.

               OPT  O+  ;Maximal optimisation.
               MC68030  ;68030 processor.
               USER     ;Privileged instructions forbidden.

gemdos         equ      1
cconout        equ      2
lf             equ      10
cr             equ      13
esc            equ      27

regs           reg      d0-d4/a0-a2

               TEXT

header:        ascii    'MSG1'              ;Header.
               movem.l  regs,-(sp)
               cmpi.w   #$0201,d0           ;$0201: game init.
               bne.s    lbl1
               lea      gsp(pc),a1
               move.l   4(a0),(a1)          ;Save the initial Game Stack Pointer.
end:           movem.l  (sp)+,regs
               jmp      ([header.w,pc])     ;Go to the next message file.

lbl1:          cmpi.w   #$0207,d0           ;$0207: msg sent by the RUL interpreter.
               bne.s    end
               movea.l  4(a0),a1            ;A1: Game Stack Pointer.
               cmpa.l   gsp(pc),a1
               beq.s    end                 ;Branch if empty stack.
               cmpi.l   #'D1LF',(a1)
               bne.s    lbl2
               moveq    #8,d4               ;Display "---------".
loop1:         moveq    #'-',d0
               bsr.s    cout
               dbf      d4,loop1
crout:         moveq    #cr,d0              ;New line (CR/LF).
               bsr.s    cout
               moveq    #lf,d0
bcout:         bsr.s    cout
               movem.l  (sp)+,regs
               rts                          ;Don't go to the next message file.

cout:          move.w   d0,-(sp)            ;Display the character D0.
               move.w   #cconout,-(sp)
               trap     #gemdos
               addq.l   #4,sp
               rts

lbl2:          cmpi.l   #'D1FF',(a1)        ;New page (Esc H).
               bne.s    lbl3
               moveq    #esc,d0
               bsr.s    cout
               moveq    #'H',d0
               bra.s    bcout

lbl3:          cmpi.l   #'D1NB',(a1)+
               bne.s    end
               moveq    #'$',d0             ;Display a 32-bit value.
               bsr.s    cout
               move.l   (a1),d3
               moveq    #7,d4
loop2:         rol.l    #4,d3
               move.w   d3,d0
               andi.w   #$F,d0
               addi.w   #'0',d0
               cmpi.w   #'9',d0
               bls.s    lbl4
               addq.w   #'A'-'9'-1,d0
lbl4:          bsr.s    cout
               dbf      d4,loop2
               bra.s    crout               ;New line.

gsp:           dc.l     0                   ;Initial Game Stack Pointer.

               END
