/*
 *  Name: rmscores.c
 *  Author: Vincent Lefevre
 *  Version: 1.00
 *  Date: 16 / 02 / 1995
 *
 *  Remove the scores
 *
 *  Usage: rmscores <rulefile> ...
 */

#include <stdio.h>
#include <stdlib.h>

enum error { ERR_RULEFILE = 1, ERR_FOPEN, ERR_CREATE, ERR_FCLOSE, ERR_FSEEK,
             ERR_FREAD, ERR_FWRITE, ERR_INSUFMEM };

main(int argc, char *argv[])
{
  int i;
  FILE *f;
  long t;
  char *p;

  for(i=1;i<argc;i++)
    { if (!(f = fopen(argv[i], "rb")))
        { fprintf(stderr, "Cannot open file %s\n", argv[i]);
          return ERR_FOPEN; }
      if (!fread(&t, 4, 1, f) || t != 'RUL3')
        { rulefile_error:
          fprintf(stderr, "File %s is not a rule file\n", argv[i]);
          return ERR_RULEFILE; }
      if (fseek(f, 0x6A, SEEK_SET))
        { fprintf(stderr, "Seek error in file %s\n", argv[i]);
          return ERR_FSEEK; }
      if (!fread(&t, 4, 1, f))
        { read_error:
          fprintf(stderr, "Read error in file %s\n", argv[i]);
          return ERR_FREAD; }
      if (t <= 0) goto rulefile_error;
      if (!(p = (char *) malloc(t)))
        { fprintf(stderr, "Insufficient memory\n");
          return ERR_INSUFMEM; }
      rewind(f);
      if (!fread(p, t, 1, f)) goto read_error;
      if (fclose(f))
        { close_error:
          fprintf(stderr, "Cannot close file %s\n", argv[i]);
          return ERR_FCLOSE; }
      p[0x36] = p[0x37] = p[0x38] = p[0x39] = 0;
      if (!(f = fopen(argv[i], "wb")))
        { fprintf(stderr, "Cannot create file %s\n", argv[i]);
          return ERR_CREATE; }
      if (!fwrite(p, t, 1, f))
        { fprintf(stderr, "Write error in file %s\n", argv[i]);
          return ERR_FWRITE; }
      if (fclose(f)) goto close_error;
    }
  return 0;
}
